class disney.rabbitRivalry.World
{
   var engine;
   var __state;
   var __camera;
   var __scroller;
   var __entitys;
   var __trees;
   var __projectiles;
   var __effects;
   var __pickups;
   var __player;
   var loop;
   var __yo;
   var __GROUND_Y = 1220;
   var __STATUE_ASSETS = ["statue_carl","statue_herman","statue_ultimoose","statue_kraggler","statue_nightmaster"];
   function World(t_engine)
   {
      this.engine = t_engine;
      this.__state = disney.rabbitRivalry.GameState.getInstance();
   }
   function start()
   {
      this.__scroller.generate(this.__camera);
   }
   function clear()
   {
      this.__entitys = [];
      this.__trees = [];
      this.__projectiles = [];
      this.__effects = [];
      this.__pickups = [];
      this.__scroller = null;
   }
   function update(dt)
   {
      if(dt > 0.2)
      {
         dt = 0.2;
      }
      this.__player.update(dt);
      this.__camera.update(dt,this.__player);
      this.__scroller.render(this.__camera,dt);
      var _loc2_ = undefined;
      var _loc5_ = undefined;
      this.loop = this.__entitys.length;
      while(this.loop--)
      {
         _loc2_ = this.__entitys[this.loop];
         if(_loc2_.doUpdate)
         {
            _loc2_.update(dt);
            if(this.__player.isFlying)
            {
               if(this.__player.runHD(_loc2_,dt))
               {
                  if(_loc2_.x - 15 < this.__player.x)
                  {
                     this.__player.bounce(true);
                  }
                  else
                  {
                     this.__player.bounce(false);
                  }
                  if(_loc2_.TYPE == "yo")
                  {
                     this.__player.grimace();
                  }
               }
            }
            else if(this.__player.isAttackFrame())
            {
               if(_loc2_.TYPE == "statue" && this.__player.runHD(_loc2_,dt))
               {
                  if(!this.__player.didHit)
                  {
                     _loc2_.takeDamage(1);
                     this.__player.didHit = true;
                     this.__state.addScore(_loc2_.scoreValue + (!this.__player.isPerfect ? 0 : 50));
                     smashing.keithm.Messenger.sendMessage("screen","runResultAnim",{type:(!this.__player.isPerfect ? "hit" : "perfect")});
                  }
               }
            }
            _loc2_.moveAndRender(this.__camera,dt);
         }
      }
      this.loop = this.__trees.length;
      while(this.loop--)
      {
         _loc2_ = this.__trees[this.loop];
         _loc2_.updateMoveAndRender(this.__camera,dt);
         if(this.__player.isFlying)
         {
            if(_loc2_.runHD(this.__player,dt))
            {
               this.__player.hitGround(_loc2_.y);
            }
         }
      }
      this.__player.moveAndRender(this.__camera,dt);
      this.loop = this.__effects.length;
      while(this.loop--)
      {
         _loc2_ = this.__effects[this.loop];
         if(_loc2_.doRemove)
         {
            this.__effects.splice(this.loop,1);
         }
         else
         {
            _loc2_.updateMoveAndRender(this.__camera,dt);
         }
      }
   }
   function generate()
   {
      this.clear();
      this.__camera = new disney.rabbitRivalry.GameCamera({dimensions:disney.rabbitRivalry.Dimensions.getInstance(),ground:this.__GROUND_Y,y:this.__GROUND_Y});
      this.__player = new disney.rabbitRivalry.ents.Player({camera:this.__camera,y:this.__GROUND_Y,x:270,owner:this});
      this.__player.spawn();
      this.__entitys = [];
      this.__trees = [];
      this.placeRandomStatues(this.__state.levelNum);
      this.__yo = new disney.rabbitRivalry.ents.Yo({camera:this.__camera,y:this.__GROUND_Y - 110,x:580,owner:this});
      this.__entitys.push(this.__yo);
      smashing.keithm.Messenger.registerAddress("world",this);
      this.__scroller = new disney.rabbitRivalry.scroller.Scroller({owner:this});
      if(this.__state.levelNum > 5)
      {
         this.__scroller.addPanel(500,"bg_night");
      }
      else
      {
         this.__scroller.addPanel(500,"bg_day");
      }
   }
   function placeRandomStatues(levelNum)
   {
      var _loc2_ = undefined;
      var _loc4_ = undefined;
      var _loc12_ = 0;
      var _loc3_ = levelNum;
      if(_loc3_ > 5)
      {
         _loc12_ = _loc3_ - 5;
         _loc3_ = 5;
      }
      while(true)
      {
         _loc3_;
         if(!_loc3_--)
         {
            break;
         }
         _loc2_ = new disney.rabbitRivalry.ents.Statue({asset:this.__STATUE_ASSETS[_loc3_],owner:this,camera:this.__camera,x:1300 + 300 * _loc3_,y:this.__GROUND_Y - 150 - Math.random() * 450,ground:this.__GROUND_Y,gold:(_loc3_ > _loc12_ - 1 ? false : true)});
         _loc2_.spawn();
         this.__entitys.push(_loc2_);
         if(_loc2_.startY < this.__GROUND_Y)
         {
            _loc4_ = new disney.rabbitRivalry.ents.Tree({x:_loc2_.startX - 110,y:_loc2_.startY,ground:this.__GROUND_Y,owner:this,camera:this.__camera});
            _loc4_.spawn();
            _loc2_.linkTree(_loc4_);
            this.__trees.push(_loc4_);
         }
      }
   }
   function enablePowerAim()
   {
      this.__player.enablePowerAndAim();
      this.__camera.zoomOut();
   }
   function onSelectWeapon(t_data)
   {
      this.__player.equip(t_data.num);
   }
   function onMouseDown()
   {
      if(this.__player.onMouseDown())
      {
         this.__camera.zoomIn(this.__player);
         this.__camera.setDelay(0.5);
      }
   }
   function onMiss()
   {
      this.__state.miss();
      smashing.keithm.Messenger.sendMessage("screen","updateLives");
      if(this.__state.isGameOver())
      {
         this.engine.onGameOver();
         return undefined;
      }
      var _loc3_ = true;
      var _loc2_ = this.__entitys.length;
      while(true)
      {
         _loc2_;
         if(!_loc2_--)
         {
            break;
         }
         if(this.__entitys[_loc2_].TYPE == "statue" && this.__entitys[_loc2_].isAlive == true)
         {
            if(this.__entitys[_loc2_].x + 15 > this.__player.x)
            {
               _loc3_ = false;
               _loc2_ = 0;
            }
         }
      }
      this.__yo.setNewTargetLoc();
      if(_loc3_)
      {
         this.goNextRabbit();
      }
      else
      {
         this.enablePowerAim();
      }
   }
   function goNextRabbit()
   {
      var _loc3_ = true;
      var _loc2_ = this.__entitys.length;
      while(true)
      {
         _loc2_;
         if(!_loc2_--)
         {
            break;
         }
         if(this.__entitys[_loc2_].TYPE == "statue" && this.__entitys[_loc2_].isAlive)
         {
            _loc2_ = 0;
            _loc3_ = false;
         }
      }
      if(_loc3_)
      {
         this.engine.onEndLevel();
         return undefined;
      }
      this.spawnNextRabbit();
   }
   function spawnNextRabbit()
   {
      this.__state.toggleRabbit();
      this.__player.requestErase();
      this.__player = new disney.rabbitRivalry.ents.Player({camera:this.__camera,y:this.__GROUND_Y,x:270,owner:this});
      this.__player.spawn();
      smashing.keithm.Messenger.sendMessage("screen","onNextRabbit");
      smashing.keithm.Messenger.sendMessage("ui","enableActiveScreenUpdates");
   }
   function onMessageReceived(message, args)
   {
      this[message](args);
   }
   function getPlayer()
   {
      return this.__player;
   }
   function get camera()
   {
      return this.__camera;
   }
}
